Subject: Re: [RFC v2 PATCH 5/4 PATCH] virtio-net: send gratuitous packet when needed

From: Rusty Russell <[email-masked]>
Date: Mon, 24 Oct 2011 14:54:59 +1030

On Sat, 22 Oct 2011 13:43:11 +0800, Jason Wang <[email-masked]> wrote:
> This make let virtio-net driver can send gratituous packet by a new
> config bit - VIRTIO_NET_S_ANNOUNCE in each config update
> interrupt. When this bit is set by backend, the driver would schedule
> a workqueue to send gratituous packet through NETDEV_NOTIFY_PEERS.
> 
> This feature is negotiated through bit VIRTIO_NET_F_GUEST_ANNOUNCE.
> 
> Signed-off-by: Jason Wang <[email-masked]>

This seems like a huge layering violation.  Imagine this in real
hardware, for example.

There may be a good reason why virtual devices might want this kind of
reconfiguration cheat, which is unnecessary for normal machines, but
it'd have to be spelled out clearly in the spec to justify it...

Cheers,
Rusty.